/* *********************************************************************************************************************
 * Copyright (c) Huawei Technologies Co., Ltd. 2022-2022. All rights reserved.
 * Description: GM
 * Create     : 2022-02-21
 * ****************************************************************************************************************** */

#ifndef GM_PKEY_H
#define GM_PKEY_H

// the included header files
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <openssl/ec.h>
#include <openssl/sm2.h>
#include <openssl/bio.h>
#include <openssl/evp.h>
#include <openssl/pem.h>
#include <openssl/err.h>
#include <openssl/engine.h>
#include <openssl/objects.h>
#include <openssl/opensslconf.h>

#include <securec.h>
#include <securectype.h>


EVP_PKEY_CTX *new_pkey_keygen_ctx(const char *alg, ENGINE *e);
unsigned char *sk_sign(EVP_PKEY *sk, const char *alg, const unsigned char *dgst,
	size_t dgstlen, size_t *siglen, ENGINE *e);
int pk_verify(EVP_PKEY *pk, const char *alg, const unsigned char *dgst,
    	size_t dgstlen, const unsigned char *sig, size_t siglen, ENGINE *e);
EVP_PKEY *pem_read_bio_pubkey(BIO *bio);
int pem_write_bio_pubkey(BIO *bio, EVP_PKEY *pkey);
int pem_write_bio_privatekey(BIO *bio, EVP_PKEY *pkey,
	const EVP_CIPHER *cipher, const char *pass);

#endif
