/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
 */

package config

import (
	"os"
	"testing"
)

func Test_Client_Config(t *testing.T) {
	configFile := "testdata/client-conf.yml"
	_, errMsg := os.Stat(configFile)
	if errMsg != nil {
		t.Errorf("CfgFilePath %s does not exist", configFile)
		return
	}

	cfg, err := NewClientConfig(configFile)
	if err != nil {
		t.Errorf("new genesis config error: %v\n", err)
		return
	}

	t.Logf("client: %v\n", cfg.Client)
	for i, node := range cfg.Nodes {
		t.Logf("node %v:  %v", i, node)
		t.Logf("node %s request port = %d, rest port %d", node.ID, node.Port, node.RestPort)
	}
}
