/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2022-2022. All rights reserved.
 */

// Package flow is the implementation of flow sdk for go client.
package flow

// AdminFlow is the role of administrator
// which is to streaming invoke chain flow
type AdminFlow struct {
	*Flow
}

func newAdminFlow(stub *stub) *AdminFlow {
	return &AdminFlow{
		Flow: &Flow{stub: stub},
	}
}

// Chain is to return ChainFlow for admin
func (a *AdminFlow) Chain() *ChainFlow {
	return newChainFlow(a.stub)
}
