package contract

type FlowOption interface {
	apply(caller *ContractCaller)
}

type FuncFlowOption struct {
	f func(caller *ContractCaller)
}

func (ffo *FuncFlowOption) apply(caller *ContractCaller) {
	ffo.f(caller)
}

func WithOrgEndorsers() FlowOption {
	return &FuncFlowOption{f: func(caller *ContractCaller) {
	}}
}

func WithListener(listener string) FlowOption {
	return &FuncFlowOption{f: func(caller *ContractCaller) {

	}}
}

func WithChainID(chain string) FlowOption {
	return &FuncFlowOption{f: func(caller *ContractCaller) {
		caller.chain = chain
	}}
}

func (c *ContractCaller) apply(opts ...FlowOption) {
	c.mu.Lock()
	for _, opt := range opts {
		opt.apply(c)
	}
	c.mu.Unlock()
}
