/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2022-2022. All rights reserved.
 */

package flow

import (
	"strings"

	"github.com/pkg/errors"
)

type orgNodeList struct {
	nodeList []string
}

type endorserFlow struct {
	*consenterFlow
	Org map[string]*orgNodeList // org1 - node1org1   node2org1
}

// GetOrgEndorser is used to get endorser node
func (e *endorserFlow) GetOrgEndorser(orgName string) (string, error) {
	return e.randomNode(e.Org[orgName].nodeList)
}

func (e *endorserFlow) orgInit() error {
	nodeMap := e.stub.gatewayClient.Nodes
	for node := range nodeMap {
		check, err := checkNodeReg(node)
		if err != nil {
			return errors.WithMessage(err, "check node reg error")
		}
		if !check {
			return errors.New("check node reg error")
		}
		stringSlice := strings.Split(node, "_")
		// check whether the key exists
		_, ifExist := e.Org[stringSlice[1]]
		if ifExist {
			tempSlice := e.Org[stringSlice[1]]
			tempSlice.nodeList = append(tempSlice.nodeList, node)
		} else {
			var NodeList []string
			NodeList = append(NodeList, node)
			s := orgNodeList{nodeList: NodeList}
			e.Org[stringSlice[1]] = &s
		}
	}
	return nil
}
