/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2022-2022. All rights reserved.
 */

package flow

// NetFlow is used to set node
type NetFlow struct {
	Flow
}

func newNetflow(stub *stub) *NetFlow {
	netFlowInstance := NetFlow{
		Flow: Flow{
			stub: stub,
		},
	}
	return &netFlowInstance
}

// AddNode is used to add nodes for sdk
func (n *NetFlow) AddNode(node ...*Node) *NetFlow {
	for _, no := range node {
		n.stub.AddNode(no.Name, no.IP, no.Host, no.Port)
	}
	return n
}

// GetNode is used to get the struct Node
func (n *NetFlow) GetNode(name string) Node {
	return n.stub.GetNode(name)
}
