/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2022-2022. All rights reserved.
 */

// Package flow is the implementation of flow sdk for go client.
package flow

// UserFlow is the role of user
// which is to streaming invoke contract flow
type UserFlow struct {
	*Flow
}

func newUserFlow(stub *stub) *UserFlow {
	UserFlowInstance := UserFlow{
		Flow: &Flow{stub: stub},
	}
	return &UserFlowInstance
}

// Contract is used to return ContractFlow
func (u *UserFlow) Contract() *ContractFlow {
	return newContractFlow(u.stub)
}
